#!/usr/bin/perl

$replP =  $ARGV[0];

@JVM_options = 
  ("-verbose:gc",
   "-Xmn300M",
   "-Xms2000M",
   "-Xmx2000M",
   "-server");

@classpath_projects = 
  (
   "/home/r/proj/rlm/src",
   "/home/r/proj/genesis/src",
#   "/home/r/proj/dylan/src",
   "/home/r/proj/pony-stories/src",
#   "/home/r/proj/data.json/src/main/clojure",
#   "/home/r/proj/curry/src",
   "/home/r/java/lib/*",
   "/home/r/proj/aurellem/src",
   "/home/r/proj/pokemon-types/src",
   "/home/r/proj/cortex/src",
   "/home/r/proj/cortex/assets",
#   "/home/r/proj/", #########################ocsenave
#   "/home/r/proj/abomination/src",
#   "/home/r/proj/abomination/classes",
#   "/home/r/proj/pony/src",
#   "/home/r/proj/coderloop/src",
   "/home/r/proj/audio-send/java/dist/audio-send.jar",
   "/home/r/proj/audio-send/java/dist/audio-send-natives.jar",
   "/home/r/proj/jmeCapture/dist/jmeCapture.jar",
   "/home/r/proj/vba-clojure/java/dist/gb-bindings.jar",
   "/home/r/proj/vba-clojure/clojure",
   "/home/r/proj/lockjaw/src"
);

@classpath_libs = 
  (
#   "/home/r/java/incanter/*",
#   "/home/r/java/enlive/src",
   "/home/r/java/lp-solve-5.5/lib/lpsolve55j.jar",
   "/home/r/proj/jMonkeyEngine3/dist/lib/eventbus.jar",
   "/home/r/proj/jMonkeyEngine3/dist/lib/jinput.jar",
   "/home/r/proj/jMonkeyEngine3/dist/lib/jME3-blender.jar",
   "/home/r/proj/jMonkeyEngine3/dist/lib/jME3-core.jar",
   "/home/r/proj/jMonkeyEngine3/dist/lib/jME3-desktop.jar",

   "/home/r/proj/jMonkeyEngine3/dist/lib/jME3-jogg.jar",
   "/home/r/proj/jMonkeyEngine3/dist/lib/jME3-lwjgl.jar",
   "/home/r/proj/jMonkeyEngine3/dist/lib/jME3-lwjgl-natives.jar",
   "/home/r/proj/jMonkeyEngine3/dist/lib/jME3-niftygui.jar",
   "/home/r/proj/jMonkeyEngine3/dist/lib/jME3-plugins.jar",
   "/home/r/proj/jMonkeyEngine3/dist/lib/jME3-terrain.jar",
   "/home/r/proj/jMonkeyEngine3/dist/lib/jME3-testdata.jar",
   "/home/r/proj/jMonkeyEngine3/dist/lib/j-ogg-oggd.jar",
   "/home/r/proj/jMonkeyEngine3/dist/lib/j-ogg-vorbisd.jar",
   "/home/r/proj/jMonkeyEngine3/dist/lib/lwjgl.jar",
   "/home/r/proj/jMonkeyEngine3/dist/lib/nifty-default-controls.jar",
   "/home/r/proj/jMonkeyEngine3/dist/lib/nifty-examples.jar",
   "/home/r/proj/jMonkeyEngine3/dist/lib/nifty.jar",
   "/home/r/proj/jMonkeyEngine3/dist/lib/nifty-style-black.jar",
   #"/home/r/proj/jMonkeyEngine3/dist/lib/noise-0.0.1-SNAPSHOT.jar",
   "/home/r/proj/jMonkeyEngine3/dist/lib/stack-alloc.jar",
   "/home/r/proj/jMonkeyEngine3/dist/lib/vecmath.jar",
   "/home/r/proj/jMonkeyEngine3/dist/lib/xmlpull-xpp3.jar",

   ###  physics, choose jbullet or bullet
   
   # jbullet -- has... special.... cone joints
   # "/home/r/proj/jMonkeyEngine3/dist/lib/jbullet.jar",
   # "/home/r/proj/jMonkeyEngine3/dist/lib/jME3-jbullet.jar",

   # bullet
   "/home/r/proj/jMonkeyEngine3/dist/opt/native-bullet/jME3-bullet.jar",
   "/home/r/proj/jMonkeyEngine3/dist/opt/native-bullet/jME3-bullet-natives.jar",

   # Genesis
   "/home/r/git/genesis/dist/*",
   "/home/r/git/genesis/jars/frame/*",
   "/home/r/git/genesis/jars/jung/*",
   "/home/r/git/genesis/jars/xstream-1.2.2/lib/xstream-1.4.3.jar",
   "/home/r/git/genesis/jars/junit/junit-4.11.jar",
   "/home/r/git/genesis/jars/google-gson-2.2.2/gson-2.2.2.jar",
   "/home/r/git/genesis/jars/textToSpeech/*",
   "/home/r/git/genesis/jars/xmlrpc/*",
   "/home/r/git/genesis/jars/jeromq/jeromq-0.2.0-SNAPSHOT.jar",
   "/home/r/git/genesis/jars/jfxrt.jar",
   "/home/r/git/genesis/jars/miscellaneous/*",
#   "/home/r/git/genesis/corpora",

   # propagators
   "/home/r/git/propagators/dist/*",
   "/home/r/git/propagators/lib/codec/*",
   "/home/r/git/propagators/lib/xmlrpc/*",
   "/home/r/git/propagators/lib/bytecode/javassist.jar",

  );

@C_libs = 
  ("/home/r/java/lp-solve-5.5/lpsolve55/bin/ux64",
   "/home/r/java/lp-solve-5.5-java/lib/ux64",
   "/home/r/proj/vba-clojure/build/artifacts/lib",
   "/usr/share/OpenCV/java/"
  );


$JVM_options = join " ", @JVM_options;
$classpath_projects = join ":", @classpath_projects;
$classpath_libs = join ":", @classpath_libs;
$C_libs = join ":", @C_libs;

$swank_launch ="clojure.main";
$swank_launch .= " -e ";
$swank_launch .= '"';
$swank_launch .= "(do (require 'swank.swank)";
$swank_launch .= "(require 'rlm.rlm-commands)";
$swank_launch .= "(swank.swank/start-repl 4005))";
$swank_launch .= '"';

$repl_launch = "clojure.main";

$clojure_command = $swank_launch;

if ($replP eq "--repl") {$clojure_command = $repl_launch;}

$command = "java $JVM_options -cp $classpath_projects:$classpath_libs" .
    " -Djava.library.path=$C_libs $clojure_command";

print "$command\n";

system($command);

